What is BatchSSH?

BatchShell 是什么
BatchShell是一款基于ssh、ftp、telnet等多协议终端、文件管理工具，可以将本地、远程主机文件同时传输到多个远程服务器，并可在多个远程服务器上同时执行命令。
具备以下主要功能：

跨主机批量文件上传、下载、拖拽同步
多服务器批量远程命令执行
本地、远程文件全文检索、文本替换
定时任务功能（文件定时同步、命令定时执行）
Putty免密管理
用户自定义命令、命令收藏、命令提示
本地、远程文件在线编辑
本地、远程文件版本控制
主机分组管理、认证管理、服务管理

详细参考:
系统概述
文件视图
服务面板
会话管理
同步记录
本地主机
本地认证


How to Install/Remove

如何安装、卸载
系统要求
Windows Server/xp/Vista/7/8/8.1/10
磁盘空间 200M
内存空间 2G

安装
获取安装文件（BatchShell-setup.exe），双击执行安装即可(部分Winodws管理端需要使用管理员权限执行打开)。
安装文件在线获取地址：http://www.batchshell.cn

卸载
点击BatchShell菜单里的 'Uninstall' ，执行卸载。


How to Order

如何购买
BatchShell是共享软件，个人用户可以免费下载、免费使用。体验完成后，订阅用户只需支付很小一笔费用即可继续使用，许可证的策略，请参考"授权协议"章节。

更多信息，请咨询售后服务人员。

软件订阅方式
1 软件内在线订阅
使用"用户"菜单里的订阅功能开通
2 联系客服
QQ:2034651032

订阅用户特权

1 主机管理数量无上限。
2 享受通过QQ和邮件的免费售后服务。
3 一次大版本免费更新 (比如2.xx -> 3.xx)。
售后技术支持
交流群 : 440402978
邮件组 : 2034651032@qq.com


批量管理

系统概述

BatchShell主体包括以下两大核心功能：
一、批量管理：
用于批量管理文件、批量执行命令
二、任务管理
用于建立定时任务，定时同步文件、定时执行命令


HTML Toolbar

同步记录面板，用于记录软件上传、下载的历史记录明细，同时做相关操作。


Document Tabs

本地主机
本地主机面板，用于对本地主机进行增加、删除、批量导入等相关操作。


Document Tabs

本地认证
本地认证面板，用于对认证信息进行本地增加、修改、删除等相关操作。


File menu commands

文件菜单命令集
文件菜单里包含以下功能:

保存 | 保存当前正在编辑的本地或者远程文件内容。
全部保存 | 保存所有编辑器中的本地或者远程文件内容。
退出 | 退出系统。


Edit menu commands

编辑菜单命令集
编辑菜单提供以下功能：
重做 | 重做文本编辑器中当前操作。
撤销 | 撤销文本编辑器中当前操作。
查找/替换 | 打开文件查找/替换对话框。


Search menu commands

窗口菜单(Windows)
窗口菜单包括以下功能:

首选项 | 打开系统首选项配置对话框。


View menu commands

用户菜单命令集
用户菜单提供以下命令:
登录 | 登录个人用户中心，查询用户订阅信息
注册 | 注册软件用户
订阅 | 订阅软件以及查询个人订阅信息


Output window Popup Menu

服务面板工具栏

服务面板工具栏包括以下功能:
以Shell方式执行命令 | 连接远程主机，并且打开默认目录
新增 | 修改当前选择主机信息
Putty | 使用Putty打开当前选择的所有主机终端
连接 | 打开所选服务的文件管理视图
最小化 | 最小化当前面板
最大化 | 最大化当前面板


New Topic

服务面板功能集

服务面板包括以下功能:
选择主机 | 通过主机名前的复选框，选择需要执行命令的主机
检索过滤 | 通过"检索过滤"输入框,输入检索关键字,对服务进行搜索，并默认选中检索出的主机
同步目录 | 通过"同步目录"输入框,批量设置文件上传目录（文件上传、下载的默认目录为服务目录）
选择主机 | 通过主机名前的复选框，选择需要批量执行命令或批量上传文件的主机
执行命令 | 选择目标主机后，通过命令输入框输入需要执行的命令，然后回车执行。若需要在终端中执行命令，请先打开目标主机终端，勾选命令输入框右侧的复选框后，再执行。


文件视图右键菜单
文件视图右键菜单包括以下功能:
打开 | 用默认编辑器打开选中的文件
同步 | 将选择的文件或文件夹同步到服务面板选中的主机目录中，若服务面板无主机选中，则同步到对侧主机目录中
打开方式 | 选择其他编辑器打开选中的文件
刷新 | 刷新选择的文件或者目录
重命名 | 重命名选择的文件或者目录
删除 | 删除选择的文件或者目录
复制 | 复制选择的本机文件或者目录
粘贴 | 将复制的内容粘贴到选择的目录中
移动 | 移动选择的文件或者目录
检索 | 在选择的文件或者目录中进行全文检索
同步缓存 | 刷新本地缓存内容
打开终端 | 打开远程终端，并切换到当前选择的目录
属性 | 查看所选文件或者文件夹的属性信息


同步记录

同步记录功能集
同步记录面板，用于记录软件上传、下载的历史记录明细，同时做相关操作。

同步记录面板包括以下功能:
重新同步 | 对选中的一条或多条记录重新进行上传或下载
断点续传 | 对停止的同步任务，在原有的任务进度基础上，重新进行同步。
取消同步 | 中止选中的正在运行的同步任务
清空记录 | 删除选中的一条或多条同步记录


本地主机

本地主机功能集
本地主机面板，用于对本地主机进行增加、删除、批量导入等相关操作。

同步记录面板包括以下功能:
添加主机 | 点击黄色加号，弹出添加主机对话框，可以添加一台或者多台主机
导入主机 | 对停止的同步任务，在原有的任务进度基础上，重新进行同步。
删除主机 | 选择一条或者多条主机，鼠标右键，删除主机。


本地认证

本地认证功能集
本地认证面板，用于对认证信息进行本地增加、修改、删除等相关操作。

本地认证面板包括以下功能:
添加认证 | 点击黄色加号，弹出添加认证对话框。密码认证请输入对应用户名、密码;若为密钥认证，请输入密钥地址。
修改认证 | 对停止的同步任务，在原有的任务进度基础上，重新进行同步。
删除删除 | 选择一条或者多条主机，鼠标右键，删除主机。


Select All command (Edit menu)
< Prev | Next >
Use this command to select the entire document.

Shortcuts
Keys: Ctrl+A


Print Progress Dialog
The Printing dialog box is shown during the time that EditPlus is sending output to the printer. The page number indicates the progress of the printing.

To abort printing, choose Cancel.


No Help Available
No help is available for this message box.


Print Preview toolbar
< Prev | Next >
The print preview toolbar offers you the following options:

Print
Bring up the print dialog box, to start a print job.
Next Page
Preview the next printed page.
Prev Page
Preview the previous printed page.
One Page / Two Page
Preview one or two printed pages at a time.
Zoom In
Take a closer look at the printed page.
Zoom Out
Take a larger look at the printed page.
Close
Return from print preview to the editing window.


Status Bar
< Prev | Next >

The status bar is displayed at the bottom of the EditPlus window. To display or hide the status bar, use the Status Bar command on the View menu.

The left area of the status bar describes actions of menu items as you use the arrow keys to navigate through menus. This area similarly shows messages that describe the actions of toolbar buttons as you depress them, before releasing them. If after viewing the description of the toolbar button command you wish not to execute the command, then release the mouse button while the pointer is off the toolbar button.

The right areas of the status bar indicates the status of the active document and the editor:

Indicator | Description
ln 1 | Current line of the active document.
col 1 | Current column of the active document.
1 | Total lines of the active document.
00 | Unicode hex value of current character.
PC | Indicates current file format. PC or UNIX.
Unicode | Indicates current file encoding. 'ANSI' for normal text files, 'Unicode'/'U BE'/'UTF-8' for Unicode/Unicode big endian/UTF-8 encodings. For other encodings, it displays the code page identifiers. For a list of the code page identifiers and corresponding languages, please see codepage.txt file in the EditPlus directory.
INS | Indicates whether current input mode is insert mode or overwrite mode.
READ | Indicates whether the active document is read-only or not.


Toolbar
< Prev | Next >

Toolbars (Standard and User) are displayed across the top of the application window, below the menu bar. The Toolbar allows quick mouse access to many tools used in EditPlus.

The Toolbar is dockable to any side of the main window and can be a resizable floating window too. You can move the Toolbar by dragging the gripper which is located at the left or top edge of the toolbar. The Toolbar can be allowed to show double column when docked vertically. See the Tools page of the Preferences dialog box.

You can customize Toolbars in Toolbar page of the Preferences dialog box.

Button | Operation
 | Opens a new document.
 | Opens an existing document. EditPlus displays the Open dialog box, in which you can locate and open the desired file.
 | Saves the active document with its current name. If you have not named the document, EditPlus displays the Save As dialog box.
 | Saves all documents.
 | Displays the document on the screen as it would appear printed.
 | Prints the active document.
 | Checks spelling in the active document.
 | Creates a blank HTML page.
 | Removes selected data from the document and stores it on the clipboard.
 | Copies the selection to the clipboard.
 | Inserts the contents of the clipboard at the insertion point.
 | Deletes the selection.
 | Reverses the last editing.
 | Reverses the last undo action.
 | Finds the specified text.
 | Replaces specific text with different text.
 | Searches for a string in multiple files.
 | Go to specified line/offset in the active document.
 | Toggles the word-wrap feature of the active document.
 | Toggles the auto-indent feature of current document.
 | Shows or hides the line number.
 | Sets the preferences. This command presents Preferences dialog box.
 | Shows or hides the cliptext window.
 | Shows or hides the Directory Window.
 | Shows or hides the output window.
 | Shows or hides the Document Tabs.
 | Toggles Full Screen mode on and off.
 | Displays help for clicked on buttons, menus and windows.
 | Quits the application; prompts to save documents.


Argument Macros
< Prev | Next >
The following macros can be used in Argument field in User Tools page of the Preferences dialog box.

Macro | Description
$(FilePath) | Inserts file name of current document with full path.
$(FileDir) | Inserts full path of current document without the file name.
$(DirWin) | Inserts the directory name displayed on the Directory Window.
$(FileName) | Inserts file name of current document without path.
$(FileNameNoExt) | Inserts file name of current document without path and extension.
$(FileExt) | Inserts file extension of current document.
$(FilePathNoDrv) | Inserts current file name and full path except the drive name.
$(FileDirNoDrv) | Inserts full path of current document without the file name and the drive name.
$(ProjectName) | Inserts current project name.
$(AppDir) | Inserts the directory of EditPlus application.
$(CurLine) | Inserts current line number where the cursor is located.
$(CurCol) | Inserts current column index where the cursor is located.
$(CurSel) | Inserts selected text.
$(CurWord) | Inserts current word.
$(CurLineText) | Inserts current line text.
$(Copy) | Copies selected text to the Clipboard.
$(Prompt) | Displays dialog box for entering custom argument.
$(WindowList) | Displays Window List dialog box and select desired file name.
$(Unicode) | Uses Unicode encoding for standard input and output.
$(UTF8) | Uses UTF-8 encoding for standard input and output.
$(Ansi) | Uses system default Windows code page for standard input and output.


Command line options and DDE commands
< Prev
Command line options
-cursor line:column | Locate cursor at "line" and "column".
-d directory | Startup directory.
-e | Load a file into an existing instance of BatchSSH.
-i directory | INI file directory.
-n | Creates a new document.
-p | Prints a file.
-pi project_ini | Specifies different project configuration file instead of project_u.ini.
-pr project | Selects a project.
-r | Opens a file as read-only.
-s directory | Syntax directory.
-t FileType | Set the file type. "FileType" must be one of the descriptions of file types on Settings & Syntax page of the Preferences dialog box.
-u | Do not add the file name to the Recent Files list.
-w | Do not load saved workspace.
-wd directory | Directory to save the workspace.
-m | Run minimized.
-sel begin:end | Selects text from "begin" position to "end" position.

DDE commands
[activate] | Activates BatchSSH.
[cursor("line:column")] | Locate cursor at "line" and "column".
[open("file")] | Opens a file.
[open_nomru("file")] | Opens a file without adding the file name to the Recent Files list.
[open_read("file")] | Opens a file as read-only.
[print("file")] | Prints a file.
[type("FileType")] | Sets the file type. See "-t" command line option.
[sel("begin:end")] | Selects text from "begin" position to "end" position. See "-sel" command line option.

DDE Service: BatchSSH.exe
DDE Topic: system

No spaces allowed in DDE commands.


Date/Time Macros
< Prev | Next >
The following macros can be used in Format field in Customize Date/Time dialog box.

Macro | Description
$(d) | Day of month.
$(dd) | Day of month with leading zero.
$(ddd) | Day of week.
$(dddd) | Day of week full name.
$(M) | Month.
$(MM) | Month with leading zero.
$(MMM) | Month abbreviation.
$(MMMM) | Month full name.
$(y) | Year.
$(yy) | Year with leading zero.
$(yyyy) | Year full four digits.
$(gg) | Period/Era.
$(h) | Hours.
$(hh) | Hours with leading zero.
$(H) | Hours in 24-hour clock.
$(HH) | Hours in 24-hour clock with leading zero.
$(m) | Minutes.
$(mm) | Minutes with leading zero.
$(s) | Seconds.
$(ss) | Seconds with leading zero.
$(t) | Time marker short.
$(tt) | Time marker long.

Date/Time macros are case-sensitive.


Directory Window Popup Menu

文
< Prev | Next >
Directory Window popup menu offers following commands:

Open | Opens the selected files.
Open As | Opens the selected files with encoding option.
Shell Open | Runs the selected files or opens them with the system default program.
Shell Menu | Shows shell context menu of the selected item.
View in Browser | Loads the file in the Directory Window into the web browser.
Insert As Tag | Inserts the file location as HTML tag.
Add to Project | Adds current file or directory to current project.
Upload | Uploads the selected files.
Refresh | Refreshes the content of the directory window.
Properties | Displays the file's properties in the Directory Window.
Show Mapped Drive Names | Displays mapped drive names.
Show Current Folder Only | Show current folder path only (old style).
File Directory | Matches the directory of the active document.
Change Directory | Changes current directory of the Directory Window.
Find in Directory | Searches for a string in selected directory.
File Name Search | Searches a file name in current directory structure.
Create | Creates a new file or directory on the Directory Window.
Rename | Changes the name of selected file or directory.
Copy to Local | Copies the selected item to the local folder you choose.
Delete | Deletes selected files or directories.
Float | Makes the Directory Window a floating window.
Hide | Hides the Side Panel.
Location | Sets the Document Tabs, Side Panel options.
Recent Directories | Goes to last directory you worked in.


Document Template
Document template offers a quick start when you create a new document.

BatchSSH offers simple document templates for HTML, C/C++, Perl and Java. You can customize it as you need on Templates page of the Preferences dialog box. Document template is a plain text file. You can define optional Hot Spot using "^!". Hot Spot will be the cursor location when the template is inserted into the document.

You can add up to 20 user-defined document template files. Document templates will be displayed on File | New menu.


BatchShell Manual

BatchShell 手册
Next >
预览
BatchShell
授权协议
安装与卸载
如何购买
功能介绍
系统概述
文件视图
服务面板
会话管理
同步记录
本地主机
本地认证
命令集
文件菜单
编辑菜单
窗口菜单
用户菜单
系统工具栏
会话管理右键菜单
服务面板右键菜单
服务面板工具栏
服务面板功能集
文件视图右键菜单
同步记录功能集
本地主机功能集
本地认证功能集


Regular Expression
< Prev | Next >
Regular expression is a search string that contains normal text plus special characters which indicate extended searching options. Regular expression allows more sophisticated search and replace.

For example, you can find any digit by using regular expression "[0-9]". Similarly you can find any matching character that is NOT digit by using regular expression "[^0-9]".

EditPlus supports following regular expressions in Find, Replace and Find in Files command.

Expression | Description
\t | Tab character.
\n | New line.
. | Matches any character.
| | Either expression on its left and right side matches the target string. For example, "a|b" matches "a" and "b".
[] | Any of the enclosed characters may match the target character. For example, "[ab]" matches "a" and "b". "[0-9]" matches any digit.
[^] | None of the enclosed characters may match the target character. For example, "[^ab]" matches all character EXCEPT "a" and "b". "[^0-9]" matches any non-digit character.
* | Character to the left of asterisk in the expression should match 0 or more times. For example "be*" matches "b", "be" and "bee".
+ | Character to the left of plus sign in the expression should match 1 or more times. For example "be+" matches "be" and "bee" but not "b".
? | Character to the left of question mark in the expression should match 0 or 1 time. For example "be?" matches "b" and "be" but not "bee".
^ | Expression to the right of ^ matches only when it is at the beginning of line. For example "^A" matches an "A" that is only at the beginning of line.
$ | Expression to the left of $ matches only when it is at the end of line. For example "e$" matches an "e" that is only at the end of line.
() | Affects evaluation order of expression and also used for tagged expression.
\ | Escape character. If you want to use character "\" itself, you should use "\\".

The tagged expression is enclosed by (). Tagged expressions can be referenced by \0, \1, \2, \3, etc. \0 indicates a tagged expression representing the entire substring that was matched. \1 indicates the first tagged expression, \2 is the second, etc. See following examples.

Original Search Replace Result
abc (ab)(c) \0-\1-\2 abc-ab-c
abc a(b)(c) \0-\1-\2 abc-b-c
abc (a)b(c) \0-\1-\2 abc-a-c


What's New
Version 3.70

<Features>
* Supports Markdown syntax highlighting and browser preview.
* Offers a native 64-bit executable.
* Improves 'Recent Directories' menu command in the Directory Window.
* Improves 'Delete Marked Lines' speed.
* Double clicking on function list now resets Find input box.
* 'Update browser preview when saving html file' option ('Preferences'->'Tools').
* Supports MyFiles subdirectory for custom syntax files that supersedes default files.
* Title bar now displays file path even when the document window is not maximized.

<Bug fixes>
* FTPS connect could fail on some servers.
* Fixes intermittent ftp error on some servers.
* FTP upload error could truncate existing file.
* Double click associated file could produce error message.
* Reload command on remote files could set wrong encoding.
* 'Save wrapped line with CR/LF' option could cause program crash.
* Find input box in the Function List cound't handle clipboard shortcuts.
* 'Go to Line/Offset' menu item didn't work.
* Replace with regular expression could not handle backslash letter correctly.
* Scroll wheel in the browser window didn't work correctly.
* 'Whole word only' option in the Find dialog box didn't work correctly.
* 'List' button in the Replace dilaog box could not handle multiple line text.
* Fixes wrong warning message that file has been deleted.
* Javascript in html file could freeze browser preview.

Version 3.60

<Features>
* Supports Function List as a tab in the Side Panel.
* Supports FTPS (FTP over TLS).
* 'Suggest' commands ('Edit').
* 'Go Back/Forward' menu command ('Search'->'Go To').
* Supports Windows 8 Spell Checking API.
* Improved regular expression support.
* Saving html file now automatically refreshes browser window.
* View in Browser 3/4 commands ('View').
* Ctrl+Mouse Wheel runs 'Larger/Smaller Font Size' command.
* 'Duplicate Sel' command ('Edit'->'Others').
* sftp supports AES algorithm.
* "Cannot find string" message now appears on the Status Bar.
* Copy command copies current line if there is no selection.
* 'New HTML Page' command creates an HTML 5 document in UTF-8 encoding.
* 'Support ' option in the Replace dialog box.
* Alt+Up/Down moves cursor to the beginning of previous/next line.
* F2 key for Rename command on the Directory Window.
* Supports $(Unicode) $(Ansi) $(UTF8) argument macros for user tools.
* Open/Save Filter User Tool groups (similar to Text Filter but applies to open/save).
* Directory Window custom filter allows multiple file patterns separated by ';'.
* 'Append' fill mode for the 'Fill Selection' dialog box.
* 'Export/Import Workspace' menu command ('File'->'Others').
* 'Apply to' option for Auto Run User Tool groups.
* Supports up to 20 Project INI files.
* 'INI File Description' menu command ('Manage Project'->'Project INI File').
* Allows environment variables in the Project file path.
* Ctrl+Alt+Mouse click runs 'Go to URL' and 'Go to File'.
* Ctrl+Shift+Mouse Wheel for page scroll.
* Supports search history for Go to Line/Offset.
* Toolbar button for 'Marker List' command.

<Bug fixes>
* Fixes possible resource leak when creating child process.
* Some sftp server could produce timeout error when uploading file.
* 'Keyboard Input' menu of Output Window didn't work correctly.
* Ruler could be shown incorrectly in variable-width fonts.
* Replace with regular expression could have wrong result.
* Directory Window could cause program crash if file list was empty.
* Fixes memory leak with the HTML Table toolbar button.
* 'Go to File' command dind't work in remote files.
* 'Go to URL' command could create new browser instance instead of adding a tab.
* On Windows XP, Chrome browser couldn't be run as an external browser.
* Zen Coding loading failure could cause program crash.
* 'Find' box in the Window List didn't work after no match found.
* Find dialog box now restores 'Find what' value between sessions.
* Paragraph HTML Toolbar button now adds closing tag.
* nbsp button on the HTML Toolbar didn't work on some conditions.
* 'Ansi to HTML' command could not be undone at once.
* 'Add to Common Files' option didn't work correctly if file type order was changed.
* &s in print footer didn't work.
* Fixes wrong brace highlighting when releasing selection.
* Directory Window follows group policy for hidden drives.
* Auto Run After Save didn't work correctly with new file.
* Default PHP function pattern now includes 'final' keyword.
* Long lines could be displayed incorrectly.
* Improves display speed on long lines.
* Word highlighting now follows case sensitive option in the Find dialog box.


Scroll bars
Displayed at the right and bottom edges of the document window. The scroll boxes inside the scroll bars indicate your vertical and horizontal location in the document. You can use the mouse to scroll to other parts of the document.